"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _webinySqlTable = require("webiny-sql-table");

var _indexes = require("./indexes");

/**
 * Contains basic indexes. If needed, this class can be extended to add additional indexes,
 * and then be set as a new indexes container as the default one.
 */
class DefaultIndexesContainer extends _webinySqlTable.IndexesContainer {
  key() {
    const index = new _indexes.KeyIndex(this.newIndexName, this, Array.from(arguments));
    this.indexes.push(index);
    return index;
  }

  primary() {
    const index = new _indexes.PrimaryIndex(this.newIndexName, this, Array.from(arguments));
    this.indexes.push(index);
    return index;
  }

  unique() {
    const index = new _indexes.UniqueIndex(this.newIndexName, this, Array.from(arguments));
    this.indexes.push(index);
    return index;
  }

  fullText() {
    const index = new _indexes.FullTextIndex(this.newIndexName, this, Array.from(arguments));
    this.indexes.push(index);
    return index;
  }

}

var _default = DefaultIndexesContainer;
exports.default = _default;
//# sourceMappingURL=indexesContainer.js.map